<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\models\TicketType;

/**
 * TicketTypeSearch represents the model behind the search form about `common\models\TicketType`.
 */
class TicketTypeSearch extends TicketType
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id_ticket_type', 'type', 'max_usage_count', 'time_unit_type', 'time_unit_count', 'price_brutto', 'id_account', 'flag_student', 'status'], 'integer'],
            [['name', 'created_at', 'updated_at'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = TicketType::find();

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'id_ticket_type' => $this->id_ticket_type,
            'type' => $this->type,
            'max_usage_count' => $this->max_usage_count,
            'time_unit_type' => $this->time_unit_type,
            'time_unit_count' => $this->time_unit_count,
            'price_brutto' => $this->price_brutto,
            'id_account' => $this->id_account,
            'flag_student' => $this->flag_student,
            'status' => $this->status,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'name', $this->name]);

        return $dataProvider;
    }
}
